#include "StdAfx.h"
#include "Derive.h"
#include <math.h>

Derive::Derive(Operation *f, Oper *by) {
	this->by=by;
	this->f=f;
	this->m=new Matrix(3);
}

double Derive::compute(double dx, double dy) {
	return tan(dy/dx);
}

double Derive::getResult() {
	double y[3], x[3];
	by->dec();
	x[0]=by->getResult();
	y[0]=f->getResult();
	by->inc();
	x[1]=by->getResult();
	y[1]=f->getResult();
	by->inc();
	x[2]=by->getResult();
	y[2]=f->getResult();
	by->dec();

	for (int i=0;i<3;i++) {
		m->set(0,i,x[i]*x[i]);
		m->set(1,i,x[i]);
		m->set(2,i,1);
		m->set(3,i,y[i]);
	}
	m->solve();
	return 2*m->get(0)*x[1]+m->get(1);


	if (x[0]==x[1]) return compute(x[2]-x[1],y[2]-y[1]);
	if (x[1]==x[2]) return compute(x[1]-x[0],y[1]-y[0]);
	return (compute(x[1]-x[0],y[1]-y[0])+compute(x[2]-x[1],y[2]-y[1]))/2.;
}

Derive::~Derive(void) {
	delete m;
}
