#pragma once

#include "Operation.h"
#include "Oper.h"
#include "Matrix.h"

class Derive : public Operation {
private:
	Matrix *m;

	Oper *by;
	Operation *f;
	double compute(double dx, double dy);

public:
	Derive(Operation *f, Oper *by);
	virtual double getResult();
	~Derive(void);
};
