#include "StdAfx.h"
#include "Oper.h"

double Oper::DELTA=0.2;

Oper::Oper(void)
{
	fromData=false;
	setValue(0);
	position=0;
}

void Oper::setValue(double value) {
	this->value=value;
}

double Oper::getResult() {
	if (fromData) {
		if (position<0) {
			printf("podteceni");
			return data->getXY(0);
		}
		if (position>=21) {
			printf("preteceni");
			return data->getXY(20);
		}
		else return data->getXY(position);
	} else return this->value;
}

void Oper::dec() {
	position--;
	setValue(value-DELTA);
}

void Oper::inc() {
	position++;
	setValue(value+DELTA);
}

void Oper::setData(Data *data) {
	this->data=data;
	fromData=true;
}

void Oper::setPosition(int position) {
	this->position=position;
}

int Oper::getPosition() {
	return position;
}

Oper::~Oper(void)
{
}
